#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire100five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five1004xi           # 100  -    


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False


shot2five1004xi = {
                1: '-10x31y94z',
                2: '-10x62y77z',
                3: '-10x67y72z',
                4: '-10x92y37z',
                5: '-12x32y93z',
                6: '-14x32y93z',
                7: '-14x62y76z',
                8: '-14x67y72z',
                9: '-159x14y119z',
                10: '-15x91y36z',
                11: '-16x32y93z',
                12: '-17x62y76z',
                13: '-18x32y92z',
                14: '-18x67y71z',
                15: '-1x0y99z',
                16: '-20x32y92z',
                17: '-20x61y75z',
                18: '-20x91y35z',
                19: '-21x67y70z',
                20: '-22x31y92z',
                21: '-24x61y75z',
                22: '-25x31y91z',
                23: '-25x66y70z',
                24: '-25x90y34z',
                25: '-27x30y91z',
                26: '-27x60y74z',
                27: '-29x29y90z',
                28: '-29x65y69z',
                29: '-2x0y99z',
                30: '-30x89y33z',
                31: '-31x28y90z',
                32: '-31x59y73z',
                33: '-32x64y68z',
                34: '-33x27y89z',
                35: '-34x58y72z',
                36: '-35x26y89z',
                37: '-35x87y32z',
                38: '-36x63y67z',
                39: '-38x24y89z',
                40: '-38x57y72z',
                41: '-39x86y31z',
                42: '-3x0y99z',
                43: '-3x29y95z',
                44: '-40x23y88z',
                45: '-40x62y67z',
                46: '-41x21y88z',
                47: '-41x55y71z',
                48: '-43x19y87z',
                49: '-43x60y66z',
                50: '-44x84y30z',
                51: '-45x17y87z',
                52: '-45x54y70z',
                53: '-47x15y86z',
                54: '-47x58y65z',
                55: '-48x13y86z',
                56: '-48x52y70z',
                57: '-48x82y29z',
                58: '-4x0y99z',
                59: '-4x30y95z',
                60: '-50x10y85z',
                61: '-50x56y64z',
                62: '-51x50y69z',
                63: '-51x8y85z',
                64: '-52x5y84z',
                65: '-53x79y28z',
                66: '-54x0y83z',
                67: '-54x3y84z',
                68: '-54x47y68z',
                69: '-54x54y64z',
                70: '-57x45y68z',
                71: '-57x51y63z',
                72: '-57x76y27z',
                73: '-5x0y99z',
                74: '-60x42y67z',
                75: '-60x49y62z',
                76: '-61x74y26z',
                77: '-63x39y66z',
                78: '-63x46y61z',
                79: '-65x36y65z',
                80: '-65x70y25z',
                81: '-66x43y61z',
                82: '-68x33y65z',
                83: '-69x39y60z',
                84: '-69x67y24z',
                85: '-6x0y99z',
                86: '-6x30y94z',
                87: '-70x30y64z',
                88: '-71x36y59z',
                89: '-72x26y63z',
                90: '-73x32y58z',
                91: '-73x64y23z',
                92: '-74x23y62z',
                93: '-76x19y61z',
                94: '-76x29y57z',
                95: '-76x60y22z',
                96: '-77x15y61z',
                97: '-78x11y60z',
                98: '-78x25y57z',
                99: '-79x21y56z',
                100: '-79x56y21z',
                101: '-7x0y99z',
                102: '-7x67y73z',
                103: '-81x17y55z',
                104: '-82x13y54z',
                105: '-82x52y20z',
                106: '-83x8y53z',
                107: '-84x4y52z',
                108: '-85x0y52z',
                109: '-85x47y19z',
                110: '-88x43y18z',
                111: '-8x0y99z',
                112: '-8x31y94z',
                113: '-90x38y17z',
                114: '-92x34y16z',
                115: '-94x29y15z',
                116: '-95x24y14z',
                117: '-97x19y13z',
                118: '-98x14y12z',
                119: '-98x9y11z',
                120: '-99x3y10z',
                121: '-9x0y99z',
                122: '0x0y99z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire100five4xi" usage = "target function for charge1004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire100five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE100FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE100FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE100FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE100FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE100FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five1004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE100FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE100FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE100FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five1004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five1004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE100FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE100FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE100FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire100five4xi.py                             
# -------------------------------------------------------------------------------------------------                   